/*************************************************
* DESX Header File                               *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_DESX_H__
#define OPENCL_DESX_H__

#include <opencl/des.h>

namespace OpenCL {

class DESX : public BlockCipher
   {
   public:
      static std::string name() { return "DESX"; }
      static const u32bit BLOCKSIZE = 8, KEYLENGTH = 24;

      void clear() throw() { des.clear(); K1.clear(); K2.clear(); }
      BlockCipher* clone() const { return new DESX; }
      DESX() : BlockCipher("DESX", BLOCKSIZE, 24) {}
   private:
      void enc(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void dec(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void key(const byte[], u32bit);
      SecureBuffer<byte, BLOCKSIZE> K1, K2;
      DES des;
   };

}

#endif
