/*************************************************
* GOST Header File                               *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_GOST_H__
#define OPENCL_GOST_H__

#include <opencl/opencl.h>

namespace OpenCL {

class GOST : public BlockCipher
   {
   public:
      static std::string name() { return "GOST"; }
      static const u32bit BLOCKSIZE = 8, KEYLENGTH = 32;

      void clear() throw() { EK.clear(); }
      BlockCipher* clone() const { return new GOST; }
      GOST() : BlockCipher("GOST", BLOCKSIZE, 32) {}
   private:
      void enc(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void dec(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void key(const byte[], u32bit);
      void round(u32bit&, u32bit) const;
      static const u32bit SBOX1[256], SBOX2[256], SBOX3[256], SBOX4[256];
      SecureBuffer<u32bit, 8> EK;
   };

}

#endif
