/*************************************************
* ISAAC Header File                              *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_ISAAC_H__
#define OPENCL_ISAAC_H__

#include <opencl/opencl.h>

namespace OpenCL {

class ISAAC : public StreamCipher
   {
   public:
      static std::string name() { return "ISAAC"; }
      static const u32bit KEYLENGTH = 32;

      void clear() throw();
      StreamCipher* clone() const { return new ISAAC; }
      ISAAC() : StreamCipher("ISAAC", 1, 32) { clear(); }
      ~ISAAC() { A = B = C = 0; }
   private:
      void cipher(const byte[], byte[], u32bit);
      void key(const byte[], u32bit);
      void generate();
      static const u32bit BUFFERSIZE = DEFAULT_BUFFERSIZE;
      SecureBuffer<u32bit, 256> state;
      SecureBuffer<byte, BUFFERSIZE> buffer;
      u32bit A, B, C, position;
   };

}

#endif
