/*************************************************
* Randpool Header File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_RANDPOOL_H__
#define OPENCL_RANDPOOL_H__

#include <opencl/opencl.h>
#include <opencl/haval.h>

namespace OpenCL {

class Randpool : public RandomNumberGenerator
   {
   public:
      static std::string name() { return "Randpool"; }

      byte random();
      void randomize(byte[], u32bit);
      void clear() throw();
      Randpool(u32bit = 12);
   private:
      typedef HAVAL_256 RANDPOOL_HASH;
      void add_randomness(const byte[], u32bit) throw();
      void generate(u64bit);
      void mix_pool();
      void reseed();
      RANDPOOL_HASH hash;
      SecureVector<byte> pool;
      SecureVector<byte> buffer;
      u32bit position, iteration;
   };

}

#endif
