/*************************************************
* Skipjack Header File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_SKIPJACK_H__
#define OPENCL_SKIPJACK_H__

#include <opencl/opencl.h>

namespace OpenCL {

class Skipjack : public BlockCipher
   {
   public:
      static std::string name() { return "Skipjack"; }
      static const u32bit BLOCKSIZE = 8, KEYLENGTH = 10;

      void clear() throw();
      BlockCipher* clone() const { return new Skipjack; }
      Skipjack() : BlockCipher("Skipjack", BLOCKSIZE, 10) {}
   private:
      void enc(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void dec(const byte[BLOCKSIZE], byte[BLOCKSIZE]) const;
      void key(const byte[], u32bit);
      void step_A(u16bit&, u16bit&, u32bit) const;
      void step_B(u16bit&, u16bit&, u32bit) const;
      void step_Ai(u16bit&, u16bit&, u32bit) const;
      void step_Bi(u16bit&, u16bit&, u32bit) const;
      static const byte F[256];
      SecureBuffer<byte, 256> FTABLE[10];
   };

}

#endif
